Main Page | Modules | Alphabetical List | Data Structures | File List | Data Fields | Globals

# uIP device driver functions
[The uIP TCP/IP stack]

## Detailed Description

These functions are used by a network device driver for interacting with uIP.

## Defines
#define | uip_input()
| Process an incoming packet.
#define | uip_periodic(conn)
| Periodic processing for a connection identified by its number.
#define | uip_periodic_conn(conn)
| Periodic processing for a connection identified by a pointer to its structure.
#define | uip_udp_periodic(conn)
| Periodic processing for a UDP connection identified by its number.
#define | uip_udp_periodic_conn(conn)
| Periodic processing for a UDP connection identified by a pointer to its structure.
## Variables
u8_t | uip_buf [UIP_BUFSIZE+2]
| The uIP packet buffer.

## Define Documentation

#define uip_input | (
|  | ) |

| Process an incoming packet. This function should be called when the device driver has received a packet from the network. The packet from the device driver must be present in the uip_buf buffer, and the length of the packet should be placed in the uip_len variable. When the function returns, there may be an outbound packet placed in the uip_buf packet buffer. If so, the uip_len variable is set to the length of the packet. If no packet is to be sent out, the uip_len variable is set to 0. The usual way of calling the function is presented by the source code below.
      uip_len = devicedriver_poll();
      if(uip_len > 0) {
        uip_input();
        if(uip_len > 0) {
          devicedriver_send();
        }
      }
  Note: If you are writing a uIP device driver that needs ARP (Address Resolution Protocol), e.g., when running uIP over Ethernet, you will need to call the uIP ARP code before calling this function:
        #define BUF ((struct uip_eth_hdr *)&uip_buf[0])
        uip_len = ethernet_devicedrver_poll();
        if(uip_len > 0) {
          if(BUF->type == HTONS(UIP_ETHTYPE_IP)) {
            uip_arp_ipin();
            uip_input();
            if(uip_len > 0) {
              uip_arp_out();
              ethernet_devicedriver_send();
            }
          } else if(BUF->type == HTONS(UIP_ETHTYPE_ARP)) {
            uip_arp_arpin();
            if(uip_len > 0) {
              ethernet_devicedriver_send();
            }
          }

#define uip_periodic | ( | conn |  | ) |

| Periodic processing for a connection identified by its number. This function does the necessary periodic processing (timers, polling) for a uIP TCP conneciton, and should be called when the periodic uIP timer goes off. It should be called for every connection, regardless of whether they are open of closed. When the function returns, it may have an outbound packet waiting for service in the uIP packet buffer, and if so the uip_len variable is set to a value larger than zero. The device driver should be called to send out the packet. The ususal way of calling the function is through a for() loop like this:
      for(i = 0; i < UIP_CONNS; ++i) {
        uip_periodic(i);
        if(uip_len > 0) {
          devicedriver_send();
        }
      }
  Note: If you are writing a uIP device driver that needs ARP (Address Resolution Protocol), e.g., when running uIP over Ethernet, you will need to call the uip_arp_out() function before calling the device driver:
        for(i = 0; i < UIP_CONNS; ++i) {
          uip_periodic(i);
          if(uip_len > 0) {
            uip_arp_out();
            ethernet_devicedriver_send();
          }
        }
  Parameters:
  conn | The number of the connection which is to be periodically polled.

#define uip_periodic_conn | ( | conn |  | ) |

  | Periodic processing for a connection identified by a pointer to its structure. Same as uip_periodic() but takes a pointer to the actual uip_conn struct instead of an integer as its argument. This function can be used to force periodic processing of a specific connection. Parameters:
  conn | A pointer to the uip_conn struct for the connection to be processed.

#define uip_udp_periodic | ( | conn |  | ) |

| Periodic processing for a UDP connection identified by its number. This function is essentially the same as uip_prerioic(), but for UDP connections. It is called in a similar fashion as the uip_periodic() function:
      for(i = 0; i < UIP_UDP_CONNS; i++) {
        uip_udp_periodic(i);
        if(uip_len > 0) {
          devicedriver_send();
        }
      }
  Note: As for the uip_periodic() function, special care has to be taken when using uIP together with ARP and Ethernet:
        for(i = 0; i < UIP_UDP_CONNS; i++) {
          uip_udp_periodic(i);
          if(uip_len > 0) {
            uip_arp_out();
            ethernet_devicedriver_send();
          }
        }
  Parameters:
  conn | The number of the UDP connection to be processed.

#define uip_udp_periodic_conn | ( | conn |  | ) |

  | Periodic processing for a UDP connection identified by a pointer to its structure. Same as uip_udp_periodic() but takes a pointer to the actual uip_conn struct instead of an integer as its argument. This function can be used to force periodic processing of a specific connection. Parameters:
  conn | A pointer to the uip_udp_conn struct for the connection to be processed.

## Variable Documentation

u8_t uip_buf[UIP_BUFSIZE+2]

  | The uIP packet buffer. The uip_buf array is used to hold incoming and outgoing packets. The device driver should place incoming data into this buffer. When sending data, the device driver should read the link level headers and the TCP/IP headers from this buffer. The size of the link level headers is configured by the UIP_LLH_LEN define. Note: The application data need not be placed in this buffer, so the device driver must read it from the place pointed to by the uip_appdata pointer as illustrated by the following example:
       void
       devicedriver_send(void)
       {
          hwsend(&uip_buf[0], UIP_LLH_LEN);
          hwsend(&uip_buf[UIP_LLH_LEN], 40);
          hwsend(uip_appdata, uip_len - 40 - UIP_LLH_LEN);
       }